/** fib.y test file for PRECCX v2.42       P.T. Breuer August 1994 **/

# define TOKEN char

# define VALUE char*

# include "ccx.h"

# include <math.h>

# define INT(x) ((int)(x))

# define DIV(m,n) INT(INT(m)/INT(n))

# define MOD(m,n) INT(INT(m)%INT(n))

# define DBLE(n)  ((double)(n))

# define LOG10(n) INT(log10(DBLE(n)))

# define TEN      DBLE(10)

# define ZERO     DBLE(0)

# define FIRSTDIGIT(n)            \
          ((PARAM)(0!=(n)?DIV((n),pow(TEN,DBLE(LOG10(n)))):ZERO))

# define LASTDIGITS(n)            \
          ((PARAM)(0!=(n)?MOD((n),pow(TEN,DBLE(LOG10(n)))):ZERO))

MAIN(fibber)

@fibber   = { fibs $! }*

@fibs     = fib((PARAM)1,(PARAM)1)\k
@           {: printf("%d terms OK\n",(int)$k); :}

@fib(a,b) = number(a) <','> fib(b,a+b)\k {@ $k+1 @}
@         | <'.'> <'.'>
@           {: printf("Next terms are %d,%d,..\n",(int)a,(int)b); :}
@                           {@ 0 @}

@number(n)= digit(n)
@         | digit(FIRSTDIGIT(n)) number(LASTDIGITS(n))

@digit(n) = <n+'0'>  /* rep. of 1 digit n */

/************************************************************
     The following are some example inputs and responses:

          1,1,2,3,5,..
          Next terms are 8,13,..
          5 terms OK

          1,1,2,3,5,8,13,21,34,51,85,..
          error: failed parse: probable error at <>1,85,..
 ************************************************************/



