/*# include "cc.h"*/
# include "occam.h"

@ literal        = real 
@                | byte 
@                | integer
@                | string 
@                | _TRUE        :printf("true") ;:
@                | _FALSE       :printf("false");:

@ integer        = digit+
@                | <'#'>        :printf("0x");:
@                  hexdigit+

@ byte           = <'\''>       :printf("'");:
@                  character
@                  <'\''>       :printf("'");:

@ real           = [sign] digit+ point digit+
@                  [<'E'>       :printf("e");:
@                   exponent]

@ string         = <'"'>        :printf("\"");:
@                  stringchar*
@                  <'"'>        :printf("\"");:

@ exponent       = sign digit+

@ digit          = (isdigit)    :printf("%c",T(1));:

@ hexdigit       = digit 
@                | { <'A'> | <'B'> | <'C'> | <'D'> | <'E'> | <'F'> }
@                               :printf("%c",tolower(T(1)));:

@ character      = [ escape ]
@                  (isascii)    :printf("%c",T(1));:

@ stringchar     = escape
@                  (isascii)    :printf("%c",T(1));:
@                | >'"'<        :printf("%c",T(1));:

@ point          = <'.'>        :printf(".");:

@ sign           = { <'-'> | <'+'> } :printf("%c",T(1));:

@ escape         = <'\\'>       :printf("\\");:

